clear all
close all
clc
%% Data loading
% load('.\Data\nms_0_Struct_001.mat');
load('.\Data\SDF_2019\ParaBoundary\nms_1_Struct_orig.mat');


%% Video
% videoname  = ['..\Local_videos\lineFit_Rec_000001'];
% writerObj = VideoWriter(videoname);
% Total_time  = 100; % total time of video in seconds
% framerate = 2;
% writerObj.FrameRate = framerate;
% open(writerObj);


%% The size of the filter
step = 5;
seg_num = 20;
dimY = 20;

% startFrame = 250;
% endFrame = 260;
startFrame = 3520;
endFrame = 3530;
% startFrame = 4524;
% endFrame = 4560;

% f1 = figure('units','normalized','outerposition',[0 0 1 1]);
for i = startFrame:1:endFrame
 
    tempFrame = nms_1_Struct(i).label;
    imshow(tempFrame);
%     
    [minX, maxX, minY, maxY] = findcorners(tempFrame);
%     hold on
%     plot(minX, minY, 'ro');
%     hold on
%     plot(maxX, maxY, 'bo');
    
    if maxY - minY <= dimY
        seg_num = 1;
    else
%         seg_num = floor((maxY - dimY) / step);
        seg_num = floor((maxY - minY) / step);
    end
%     dimY = maxY - minY +1;
    
    for j = 1:1:seg_num
%         subFrame = tempFrame(  (minY + (j-1)*step + 1):((minY + (j-1)*step) + dimY), minX:maxX);
        subFrame = tempFrame(  (minY + (j-1)*step):((minY + (j-1)*step) + dimY), minX:maxX);

        %         imshow(subFrame);
         [B, L, N, A] = bwboundaries(subFrame);
         if size(B,1) ~= 2
             continue;
         else
             for k = 1:1:2
                    pts = B{k,1};

                    x = pts(:,1) +  (minY + (j-1)*step + 1);
                    y = pts(:,2) + minX;
                    hold on
                    plot(y, x, 'LineWidth', 2);
                    pause(0.05)
                    tempLine = polyfit(x, y, 1);
%                     disp(['Equation is y = ' num2str(tempLine(1)) '*x + ' num2str(tempLine(2))])
                    y_est = polyval(tempLine, x);
                    hold on
                    plot( y_est, x, 'r--','LineWidth',2);
                    pause(0.05)
                    
                    Line(j).line(k).y_est = y_est;
                    Line(j).line(k).x = x;
                    Line(j).line(k).para = tempLine;
%                     hold on

             end
         end
    end
cellLine{i,1} = Line;
% F = imcapture(f1);
% writeVideo(writerObj,F);
%     close figure
end
%  close(writerObj);  

