close all
clear all
clc

%% Paths where the original data, the edges got from pdollar algorithm
% disp('Input the Series Number of the video you want to process!');
% videoID = input('Input the number:  ');
% disp(['Your choise is:'  num2str(videoID)]);
% 
% nmsedgpath = strcat('..\image\Edge\Rec_000', num2str(videoID));
% edgpath =  strcat('..\image\Edge_Hough\Rec_000', num2str(videoID));
% imgpath = strcat('..\image\Optical\Rec_000', num2str(videoID));

% nmsedgpath = strcat('E:\LSS-03-07-2019\edges-master\edges-master\LSS_codes\Data\SDF_2019\HomoEdge\Rec-000130', '130');
nmsedgpath =  strcat('.\Data\SDF_2019\HomoEdge\');
imgpath = strcat('.\Data\SDF_2019\OrigAfterHomo\');

%% Start and End frame index, tarDir is where the images are stored
% disp('Input the Start Frame you want to process!');
% frameID = input('Input the number:  ');
% disp(['Your choise is:'  num2str(frameID)]);
% 
% startFrame = frameID; 
% tarDir = dir(strcat(imgpath, '\', '*.png'));
% endFrame = length(tarDir);

% startFrame = 250;
% endFrame = 400;

startFrame = 3520;
endFrame = 3530;
%% Size of the pictures, not necessarily needed
Width = 704;
Height = 480;
% Width = 1024;
% Height = 768;
%% Video
videoname  = ['..\Local_videos\framesEdge_Rec_000001'];
writerObj = VideoWriter(videoname);
Total_time  = 100; % total time of video in seconds
framerate = 2;
writerObj.FrameRate = framerate;
open(writerObj);

f1 = figure('units','normalized','outerposition',[0 0 1 1]);

for i = startFrame:endFrame
%% Read in a frame from the original video data
    fileName = sprintf('%d',i);
    fileName = strcat('im_',fileName);
    Iorigin = imread([imgpath '\' fileName,'.jpg']);
    frames = Iorigin;
  
%% Convert to black and white image
    frames = rgb2gray(frames);
    framesBW = imbinarize(frames, 0.4); %black and white
    
%% Parameters for mophorlogical processing
    se = strel('square',13);
    framesBW_DI = imdilate(framesBW, se); %dilate the bw mask

%% Read in frames from the edges got from pdollar algorithm with nms=0 and nms=1, respectively
%     frameEdge =  imread(strcat(edgpath,'\',  'im_', num2str(i), '.png'));
    frameNmsEdge =  imread(strcat(nmsedgpath,'\',  'im_', num2str(i), '.jpg'));
    [Height, Width] = size(frameNmsEdge);
    for w = 1:Width
        for h = 1:Height
            if framesBW_DI(h,w) < 1
%                 frameEdge(h,w) = 255;
                frameNmsEdge(h,w) = 255;
            end
        end
    end

 %% Morphology to sharpen the edge
     %se2 = strel('square',2);
 
% %%%% NMS = 0
%      frameEdge = imerode(frameEdge,se2);
%      frameEdge = imdilate(frameEdge,se2);
%      frameEdge = imdilate(frameEdge,se2);
%      frameEdge = imdilate(frameEdge,se2);
%      frameEdge = imdilate(frameEdge,se2);
     
%%%% NMS = 1  
    % frameNmsEdge = imerode(frameNmsEdge,se2);
%      frameNmsEdge = imdilate(frameNmsEdge,se2);
%      frameNmsEdge = imdilate(frameNmsEdge,se2);
%      frameNmsEdge = imdilate(frameNmsEdge,se2);
%      frameNmsEdge = imdilate(frameNmsEdge,se2);
     
%%%% Strenthen the edge
%     for w=1:Width
%         for h=1:Height
%             if frameEdge(h,w) < 240
%                 frameEdge(h,w) = frameEdge(h,w)*0.9;
%                 frameNmsEdge(h,w) = frameNmsEdge(h,w)*0.9;
%             end
%         end
%     end
%     
%% use Canny method to extract edges
%     1. canny_v0 is canny with a Gaussian filter
%     2. edge(frameEdge,'Canny',0.1) is from MATLAB

% %% Edges from pdollar with NMS = 0
% 
% %%%% Further processing of edges from pdollar
% %     testEdge=edge(frameEdge,'Canny',0.1);
%     testEdge = canny_v0(frameEdge);     % edge extraction with Canny
%     testEdge = imdilate(testEdge,se2);    % dilate the edge
%   
% %%%% Boundaries extraction
%     [B_0, L_0, N_0, A_0] = bwboundaries(testEdge);
%     nms_0_Struct(i).coor = B_0;   % Row and column coordinates of boundary pixels
%     nms_0_Struct(i).label = L_0;   % Label matrix
%     nms_0_Struct(i).num = N_0;   % Number of objects found
%     nms_0_Struct(i).adj = A_0;     % Parent-child dependencies between boundaries and holes
 
%% Edges from pdollar with NMS = 1
    testnmsEdge=im2bw(frameNmsEdge,0.8);
    testnmsEdge=~testnmsEdge(:,:,1);
%testnmsEdge = edge(frameNmsEdge,'Canny',0.1);
%     testnmsEdge = canny_v0(frameNmsEdge);    % edge extraction with Canny   
%  testnmsEdge = imdilate(testnmsEdge,se2);    % dilate the edge
    
%%%% Boundaries extraction
    [B_1, L_1, N_1, A_1] = bwboundaries(testnmsEdge,'noholes');
    nms_1_Struct(i).coor = B_1;   % Row and column coordinates of boundary pixels
    nms_1_Struct(i).label = L_1;   % Label matrix
    nms_1_Struct(i).num = N_1;   % Number of objects found
    nms_1_Struct(i).adj = A_1;     % Parent-child dependencies between boundaries and holes

%% Make a copy of the Iorigin, 'I' here is capital 'i'
    Iorigincp = Iorigin;
    
%%%% Visualize the edges: NMS = 0
%      for w=1:Width
%         for h=1:Height
%             if testEdge(h,w) == 1
%                Iorigin(h,w,1) = uint8(255);
%                Iorigin(h,w,2) = uint8(0);
%                Iorigin(h,w,3) = uint8(0);
%             end
%         end
%      end
%%%% Visualize the edges: NMS = 1
     for w=1:Width
        for h=1:Height
            if testnmsEdge(h,w) == 1
               Iorigincp(h,w,1) = uint8(255);
               Iorigincp(h,w,2) = uint8(0);
               Iorigincp(h,w,3) = uint8(0);
            end
        end
     end

%% Show the edges
%      pic = cat(1,Iorigin, Iorigincp);
     pic = Iorigincp;
     imshow(pic)
%      montage(pic)
%     imshowpair(Iorigin, Iorigincp)

    colors=['b' 'g' 'r' 'c' 'm' 'y'];
     
%     subplot(2,1,1); imshow(Iorigin)
%     hold on;
%     for k=1:length(B_0)
%       boundary_0 = B_0{k};
%       cidx = mod(k,length(colors))+1;
%       plot(boundary_0(:,2), boundary_0(:,1),...
%            colors(cidx),'LineWidth',1);
%     end
    
    imshow(Iorigincp)
    hold on;
    for k=1:length(B_1)
      boundary_1 = B_1{k};
      cidx = mod(k,length(colors))+1;
      plot(boundary_1(:,2), boundary_1(:,1),...
           colors(cidx),'LineWidth',1);
    end
    
    pause(0.005)




% %% Show the boundaries
%     hold on;
%     colors=['b' 'g' 'r' 'c' 'm' 'y'];
%     for k=1:length(B),
%       boundary = B{k};
%       cidx = mod(k,length(colors))+1;
%       plot(boundary(:,2), boundary(:,1),...
%            colors(cidx),'LineWidth',2);
% 
%       %randomize text position for better visibility
%       rndRow = ceil(length(boundary)/(mod(rand*k,7)+1));
%       col = boundary(rndRow,2); row = boundary(rndRow,1);
%       h = text(col+1, row-1, num2str(L(row,col)));
%       set(h,'Color',colors(cidx),'FontSize',14,'FontWeight','bold');
%     end
%     pause(0.005)

%% Video
    F = imcapture(f1);
    writeVideo(writerObj,F);
end
 close(writerObj);   
